import 'package:get/get.dart';
import 'package:wowit/controllers/connect_controller.dart';

abstract class BaseController extends GetxController {
  final Map<String, List<Map<String, Object>>> _data = {};

  bool get isOnline => MyConnectivity.instance.isOnline;

  final Map<String, String> messageIdBackUp = {};

  Future<Map<String, List<Map<String, Object>>>?> loadData();

  void onInitGetX() {
    printInfo(info: toString() + ' onInitGetX');
  }

  Map<String, List<Map<String, Object>>> getData() {
    return _data;
  }

  void setData(Map<String, List<Map<String, Object>>> data) {
    _data.clear();
    _data.addAll(data);
  }

  void clearData() {
    _data.clear();
  }
}
