import 'package:flutter/material.dart';
import 'package:get/get.dart';

class LoadingScreen extends StatelessWidget {
  const LoadingScreen({super.key});
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(
        child: Image.asset(
          'assets/images/loading_screen.png',
          height: 200,
        ),
      ),
    );
  }
}

class NoInternetScreen extends StatelessWidget {
  const NoInternetScreen({super.key});

  @override
  Widget build(BuildContext context) {
    return Center(
      child: Image.asset(
        'assets/images/404-error.png',
        height: 100,
        width: 100,
      ),
    );
  }
}

class MessageListScreen extends StatelessWidget {
  const MessageListScreen({
    super.key,
    this.data = const {},
  });

  final Map<String, String> data;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: Colors.white,
        title: const Text(
          'Danh sách message',
          style: TextStyle(
            color: Color(0xff2a367e),
            fontSize: 20,
          ),
        ),
        leading: IconButton(
          icon: const Icon(
            Icons.arrow_back_ios_rounded,
            color: Color(0xff2a367e),
            size: 24.0,
          ),
          onPressed: () {
            Get.back();
          },
        ),
      ),
      body: ListView.separated(
        padding: const EdgeInsets.all(16),
        separatorBuilder: (_, __) => const Divider(),
        itemCount: data.length,
        itemBuilder: (_, index) {
          String key = data.keys.elementAt(index);
          return Column(
            children: [
              Text('Key: $key'),
              const SizedBox(width: 16),
              Text('Message: ${data[key]}')
            ],
          );
        },
      ),
    );
  }
}
