part of edit_screen;

class ConfirmBottomSheet extends StatelessWidget {
  const ConfirmBottomSheet(this.editorController, {super.key});

  final EditorController editorController;

  @override
  Widget build(BuildContext context) {
    return Container(
      height: 120,
      width: MediaQuery.of(context).size.width - 40,
      decoration: BoxDecoration(
          borderRadius: const BorderRadius.only(
            topLeft: Radius.circular(15),
            topRight: Radius.circular(15),
          ),
          border: Border.all(
            color: Common.colorAppbar,
          )),
      child: Padding(
        padding: const EdgeInsets.all(20),
        child: Column(
          children: <Widget>[
            Text(
              Message.getMessage('EditorWidget_xac_nhan_luu_thong_tin'),
              style: TextStyle(color: Common.colorAppbar, fontSize: 20),
              overflow: TextOverflow.ellipsis,
            ),
            const SizedBox(height: 20),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceAround,
              children: [
                ConfirmOutlinedButton(
                  onPressed: () {
                    editorController._isConfirm.value = false;
                    Get.back();
                  },
                  icon: const Icon(
                    Icons.close_outlined,
                    color: Colors.orange,
                  ),
                ),
                ConfirmOutlinedButton(
                  onPressed: () async {
                    editorController._isConfirm.value = false;
                    Get.back();
                    await editorController.save();
                  },
                  icon: const Icon(
                    Icons.done_outlined,
                    color: Colors.green,
                  ),
                ),
              ],
            )
          ],
        ),
      ),
    );
  }
}

class ConfirmOutlinedButton extends StatelessWidget {
  const ConfirmOutlinedButton({
    super.key,
    required this.onPressed,
    required this.icon,
  });

  final VoidCallback onPressed;
  final Icon icon;

  @override
  Widget build(BuildContext context) {
    return Container(
      constraints: const BoxConstraints.tightFor(height: 32, width: 80),
      child: OutlinedButton(
        onPressed: onPressed,
        style: OutlinedButton.styleFrom(
          shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.circular(10.0),
          ),
          side: BorderSide(
            width: 1,
            color: Common.colorAppbar,
          ),
        ),
        child: icon,
      ),
    );
  }
}
