import 'package:flutter/services.dart';
import 'package:intl/intl.dart';

class PriceInputFormatter extends TextInputFormatter {
  static String format(String value) {
    return NumberFormat.decimalPattern('en').format(int.parse(value));
  }

  @override
  TextEditingValue formatEditUpdate(
      TextEditingValue oldValue, TextEditingValue newValue) {
    String text = '';

    if (newValue.text.isNotEmpty) {
      text = format(newValue.text);
    }

    return newValue.copyWith(
      text: text,
      selection: TextSelection.collapsed(
        offset: text.length,
      ),
    );
  }
}
