import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:wowit/widgets/log_widget/log_controller.dart';

class LogWidget extends StatefulWidget {
  const LogWidget({Key? key}) : super(key: key);

  @override
  State<LogWidget> createState() => _LogWidgetState();
}

class _LogWidgetState extends State<LogWidget> {
  Color colorIcon = Get.theme.textTheme.headline1!.color??Colors.blue;
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: Colors.white,
        title: const Text('Danh sách log'),
        centerTitle: true,
        leading: IconButton(
        icon: Icon(
          Icons.arrow_back_ios_rounded,
          size: 24.0,
          color: colorIcon,
        ),
        onPressed: () {
          Get.back();
        },
      ),
      ),
      body: Padding(
        padding: const EdgeInsets.symmetric(horizontal: 8),
        child: _bodyWidget(),
      ),
      bottomNavigationBar: _clearLog(),
    );
  }

  Widget _bodyWidget() {
    return ListView(
      children: [SelectableText(LogController.getLog())],
    );
  }

  Widget _clearLog(){
    return SizedBox(
      height: 50,
      child: ElevatedButton(
        style: OutlinedButton.styleFrom(
          backgroundColor: colorIcon
        ),
        onPressed: (){
        setState(() {
          LogController.clearLog();
        });
      },
      child: const Center(child: Text('Clear log')),
      ),
    );
  }
}
