part of wow_cache_manager;

abstract class _BaseCacheManager extends CacheManager {
  _BaseCacheManager(super.config);

  /// Lấy file theo địa chỉ link
  ///
  /// nếu file chưa được lưu dưới cache thì sẽ lưu ở đây
  Future<File> getCacheFile(String url) {
    return getSingleFile(url, key: _getFileKey(url));
  }

  /// Xoá file lưu dưới cache theo địa chỉ link
  @override
  Future<void> removeFile(String url) {
    String key = _getFileKey(url);
    return super.removeFile(key);
  }

  Future<bool> isCached(String url) async {
    final cacheFile = await getFileFromCache(_getFileKey(url));
    if (cacheFile != null) {
      return true;
    }
    return false;
  }

  Future<File> saveToCache(String url) async {
    return (await downloadFile(url, key: _getFileKey(url))).file;
  }

  String _getFileKey(String url) {
    String key = url;
    String name = url.split('/').last;
    if (name.isNotEmpty) {
      key = name;
    }
    return key;
  }
}
